<?php
/**
* @version		1.0.0 
* @author       fonclub
* @email        sfonclub@gmail.com
* @package		Joomla
* @subpackage	Virtuemart pricechanger
* @copyright	Copyright (C) 2012 WebseoMaster Studio. All rights reserved.
*/

// Check to ensure this file is included in Joomla!

Defined ('_JEXEC')  or  die();

jimport( 'joomla.application.component.model' );

require_once "../administrator/components/com_virtuemart/classes/ps_database.php";


class PricechangerModelPricechanger extends JModel
{

    function list_manufacturer($manufacturer_id='0') {

		$db = new vm_ps_DB;

		$q = "SELECT manufacturer_id as id,mf_name as name FROM #__{vm}_manufacturer ORDER BY mf_name";
		$db->query($q);
		$db->next_record();

		// If only one vendor do not show list
		if ($db->num_rows() == 1) {

			$code = '<input type="hidden" name="manufacturer_id" value="'. $db->f("id").'" />';
		}
		elseif( $db->num_rows() > 1) {
			$db->reset();
			$array = array();
			while ($db->next_record()) {
				$array[$db->f("id")] = $db->f("name");
			}
			$code = $this->selectList('id_manufacture', $manufacturer_id, $array ). "<br />\n";			
		}
        return $code;
	}
    
    function selectList($name, $value, &$arr, $size=1, $multiple="", $extra="") {
		$html = '';
		if( empty( $arr ) ) {
			$arr = array();
		}
		$html = "<select class=\"inputbox\" name=\"$name\" size=\"$size\" $multiple $extra>\n";

		foreach($arr as $key => $val) {
			$selected = "";
			if( is_array( $value )) {
				if( in_array( $key, $value )) {
					$selected = "selected=\"selected\"";
				}
			}
			else {
				if(strtolower($value) == strtolower($key) ) {
					$selected = "selected=\"selected\"";
				}
			}
			$html .= "<option value=\"$key\" $selected>".$this->shopMakeHtmlSafe($val);
			$html .= "</option>\n";
		}

		$html .= "</select>\n";
		
		return $html;
	}
    
    function list_categories($name, $category_id, $selected_categories=Array(), $size=1, $toplevel=true, $multiple=false, $disabledFields=array() ) {
		global $VM_LANG;
		
		$db = new vm_ps_DB;

		$q  = "SELECT category_parent_id FROM #__{vm}_category_xref ";
		if( $category_id ) {
			$q .= "WHERE category_child_id='$category_id'";
		}
		$db->query( $q );
		$db->next_record();
		$category_id=$db->f("category_parent_id");
		$multiple = $multiple ? "multiple=\"multiple\"" : "";
		$id = str_replace('[]', '', $name );
		$code = "<select class=\"inputbox\" size=\"$size\" $multiple name=\"$name\" id=\"$id\">\n";
		if( $toplevel ) {
			$code .= "<option value=\"0\">Выберите категорию</option>\n";
		}
		$code .= $this->list_tree($category_id, '0', '0', $selected_categories, $disabledFields );
		$code .= "</select>\n";
        return $code;
	}
    
    function list_tree($category_id="", $cid='0', $level='0', $selected_categories=Array() ) {

		//$ps_vendor_id = $_SESSION["ps_vendor_id"];
		$db = new vm_ps_DB;

		$level++;

		$q = "SELECT category_id, category_child_id,category_name FROM #__{vm}_category,#__{vm}_category_xref ";
		$q .= "WHERE #__{vm}_category_xref.category_parent_id='$cid' ";
		$q .= "AND #__{vm}_category.category_id=#__{vm}_category_xref.category_child_id ";
		//$q .= "AND #__{vm}_category.vendor_id ='$ps_vendor_id' ";
		$q .= "AND #__{vm}_category.category_publish ='Y' ";
		$q .= "ORDER BY #__{vm}_category.list_order, #__{vm}_category.category_name ASC";
		$db->setQuery($q);   $db->query();
        
        $code = '';

		while ($db->next_record()) {
			$child_id = $db->f("category_child_id");
			if ($child_id != $cid) {
				$selected = ($child_id == $category_id) ? "selected=\"selected\"" : "";
				if( $selected == "" && @$selected_categories[$child_id] == "1") {
					$selected = "selected=\"selected\"";
				}
				$code .= "<option $selected value=\"$child_id\">\n";
			}
			for ($i=0;$i<$level;$i++) {
				$code .= "&#151;";
			}
			$code .= "|$level|";
			$code .= "&nbsp;" . $db->f("category_name") . "</option>";
			$code .= $this->list_tree($category_id, $child_id, $level, $selected_categories);            
		}
        return $code;
	}
    
    function shopMakeHtmlSafe( $string, $quote_style='ENT_QUOTES', $use_entities=false ) {
    	if( defined( $quote_style )) {
    		$quote_style = constant($quote_style);
    	}
    	if( $use_entities ) {
    		$string = @htmlentities( $string, constant($quote_style) );
    	} else {
    		$string = @htmlspecialchars( $string, $quote_style );
    	}
    	return $string;
    }
    
    function getProductsByCat($categories_id){           
        $db = JFactory::getDBO();
        $products = array();
        
        if(is_array($categories_id)){
            foreach($categories_id as $cat_id){
                $db->setQuery('SELECT product_id FROM #__vm_product_category_xref WHERE category_id ='.(int)$cat_id.'');
                if(!$db->loadResultArray()){
                    echo $db->getErrorMsg();
                }
                $products[] = $db->loadResultArray();  
            }
        }          
        return $this->makeAssoc($products); /** преобразуем результат в ассоциативный массив и возвращаем*/
    }
    
    function getProductsByManufacture($id_manufacture, $products_in_cat){           
        $db = JFactory::getDBO();
        $db->setQuery('SELECT product_id FROM #__vm_product_mf_xref WHERE manufacturer_id ='.(int)$id_manufacture.' AND product_id IN ('. implode(",", $products_in_cat) .')');
        if(!$db->loadResultArray()){
           echo $db->getErrorMsg();
        }
        $rows = $db->loadResultArray();        
        return $rows;
    }
    
    function changePriceProduct($product_id, $upprice=NULL, $downprice=NULL, $test='off'){
        
        $db = JFactory::getDBO();
        $db->setQuery('SELECT product_price FROM #__vm_product_price WHERE product_id ='.(int)$product_id);
        if(!$db->loadResult()){
           echo $db->getErrorMsg();
        }
        $oldprice = $db->loadResult();/** старая цена*/ 
        
        if($upprice !== 0){
            $percent = (100+$upprice)*0.01;
        }  
        
        if($downprice !== 0){
            $percent = (100-$downprice)*0.01;
        }      
                        
        $newprice = $oldprice*$percent;/** новая цена*/
        $newprice = round($newprice,2); /** округляем до сотых*/
        //$newprice = sprintf('%f', $newprice); 
        
        if($test == 'off'){
            $db->setQuery('UPDATE #__vm_product_price SET product_price = '. $newprice .' WHERE product_id ='.(int)$product_id);
            if(!$db->query()){
               echo $db->getErrorMsg();
            }
        }       
        
        $db->setQuery('SELECT product_name FROM #__vm_product WHERE product_id ='.(int)$product_id);
        if(!$db->loadResult()){
           echo $db->getErrorMsg();
        }
        $name = $db->loadResult();
        return "Товар $name , старая цена - $oldprice, новая цена - $newprice <br />";
    }
    
    function makeAssoc ($arr, $offset = 0)
    {
      $assoc = array();
     
      foreach ($arr as $k=>$v)
      {
        if (is_array($v))
        {
          $assocTemp = $this->makeAssoc($v, $offset);
          $assoc += $assocTemp;
          $offset += count($assocTemp);
        }
        else
        {
          $assoc[$offset] = $v;
          ++$offset;
        }
      }
      return $assoc;
    }

}